/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["./chunks/tslib.es6","./WebDocument2D","./core/Collection","./core/Error","./core/loadAll","./core/accessorSupport/decorators/property","./core/has","./core/Logger","./core/RandomLCG","./core/accessorSupport/decorators/subclass","./networks/UtilityNetwork","./webdoc/GeotriggersInfo","./webdoc/IPSInfo","./webmap/InitialViewProperties","./webmap/utils","./webmap/Version"],(function(e,t,r,o,s,i,n,p,c,a,l,u,d,w,y,h){"use strict";const b={currentVersion:y.currentVersion,createInitialViewProperties:()=>new w,parseVersion:h.Version.parse,itemType:"Web Map",name:"webmap",origin:"web-map"},f=r.ofType(l);let m=class extends t{constructor(e){super(e),this.geotriggersInfo=null,this.ipsInfo=null,this.presentation=null,this.utilityNetworks=null}destroy(){if(this.utilityNetworks){const e=this.utilityNetworks.removeAll();for(const t of e)t.destroy();this.utilityNetworks.destroy()}}get context(){return b}loadAll(){return s.loadAll(this,(e=>{e(this.ground,this.basemap,this.layers,this.tables,this.ipsInfo?.positioningService?.portalItem)}))}static fromJSON(e){if(e)return new this({resourceInfo:e});throw new o("webmap:empty-resource","Expected a JSON resource but got nothing")}};m.VERSION=y.currentVersion,e.__decorate([i.property({type:u,json:{write:!0}})],m.prototype,"geotriggersInfo",void 0),e.__decorate([i.property({type:d,json:{write:!0,name:"mapIPSInfo"}})],m.prototype,"ipsInfo",void 0),e.__decorate([i.property({json:{write:!0}})],m.prototype,"presentation",void 0),e.__decorate([i.property({type:f,json:{read:!0,write:!0}})],m.prototype,"utilityNetworks",void 0),m=e.__decorate([a.subclass("esri.WebMap")],m);return m}));
