/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../geometry","../core/Clonable","../core/Cyclical","../core/JSONSupport","../core/maybe","../core/accessorSupport/decorators/property","../core/accessorSupport/decorators/cast","../core/RandomLCG","../core/has","../core/accessorSupport/decorators/subclass","../core/accessorSupport/ensureType","../core/accessorSupport/decorators/persistable","../geometry/Point"],(function(e,t,r,o,s,i,p,a,c,l,n,u,d,y){"use strict";let h=class extends(r.ClonableMixin(s.JSONSupport)){constructor(e){super(e),this.type="plane",this.position=null,this.heading=0,this.tilt=0,this.width=10,this.height=10}equals(e){return this.heading===e.heading&&this.tilt===e.tilt&&i.equalsMaybe(this.position,e.position)&&this.width===e.width&&this.height===e.height}};e.__decorate([p.property({readOnly:!0,json:{read:!1,write:!0}})],h.prototype,"type",void 0),e.__decorate([p.property({type:y}),d.persistable()],h.prototype,"position",void 0),e.__decorate([p.property({type:Number,nonNullable:!0,range:{min:0,max:360}}),d.persistable(),a.cast((e=>o.cyclicalDegrees.normalize(u.ensureNumber(e),0,!0)))],h.prototype,"heading",void 0),e.__decorate([p.property({type:Number,nonNullable:!0,range:{min:0,max:360}}),d.persistable(),a.cast((e=>o.cyclicalDegrees.normalize(u.ensureNumber(e),0,!0)))],h.prototype,"tilt",void 0),e.__decorate([p.property({type:Number,nonNullable:!0}),d.persistable()],h.prototype,"width",void 0),e.__decorate([p.property({type:Number,nonNullable:!0}),d.persistable()],h.prototype,"height",void 0),h=e.__decorate([n.subclass("esri.analysis.SlicePlane")],h);return h}));
