/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/shading/EvaluateAmbientLighting.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/Gamma.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/PhysicallyBasedRenderingParameters.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/PiUtils.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/CloudsParallaxShading.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/ColorConversion.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/RgbaFloatEncoding.glsl","../views/3d/webgl-engine/core/shaderModules/Float3PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/shaders/ScreenSpacePassAtmosphere.glsl"],(function(e,i,l,r,s,n,a,o,d,g,c,t,u){"use strict";function b(){const e=new t.ShaderBuilder,{fragment:b}=e;return e.include(u.ScreenSpacePassAtmosphere,{needUVs:!1,needEyeDirection:!1}),b.include(a.ColorConversion),b.include(o.RgbaFloatEncoding),e.include(i.EvaluateAmbientLighting,{pbrMode:r.PBRMode.Disabled,lightingSphericalHarmonicsOrder:2}),e.include(s.PiUtils),e.include(l.Gamma),e.include(n.CloudsParallaxShading),b.uniforms.add(new d.Float3PassUniform("cameraPosition",((e,i)=>i.camera.eye)),new g.FloatPassUniform("cloudsOpacity",((e,i)=>i.clouds.opacity))).main.add(c.glsl`vec4 cloudsColor = renderClouds(normalize(worldRay), cameraPosition);
fragColor = vec4(cloudsOpacity * cloudsColor.rgb, cloudsColor.a);`),e}const w=Object.freeze(Object.defineProperty({__proto__:null,build:b},Symbol.toStringTag,{value:"Module"}));e.CloudsComposition=w,e.build=b}));
