/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ScreenSpacePass.glsl","../views/3d/webgl-engine/core/shaderLibrary/output/ReadDepth.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/RgbaFloatEncoding.glsl","../views/3d/webgl-engine/core/shaderModules/Float2PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform","../views/3d/webgl-engine/shaders/CompositingTechniqueConfiguration"],(function(e,r,a,n,s,i,o,t,l,d){"use strict";class g extends o.NoParameters{constructor(){super(...arguments),this.opacity=1}}function c(e){const g=new t.ShaderBuilder;g.include(r.ScreenSpacePass),g.fragment.uniforms.add(new l.Texture2DPassUniform("tex",(e=>e.texture))),e.hasOpacityFactor&&g.fragment.uniforms.add(new i.FloatPassUniform("opacity",(e=>e.opacity)));const c=e.blitMode===d.BlitMode.Depth;return c&&(g.fragment.uniforms.add(new s.Float2PassUniform("nearFar",((e,r)=>r.camera.nearFar))),g.fragment.include(a.ReadDepth),g.fragment.include(n.RgbaFloatEncoding)),g.fragment.main.add(o.glsl`
    ${c?o.glsl`
          float normalizedLinearDepth = (-linearDepthFromTexture(tex, uv) - nearFar[0]) / (nearFar[1] - nearFar[0]);
          fragColor = float2rgba(normalizedLinearDepth);`:o.glsl`
          fragColor = texture(tex, uv) ${e.hasOpacityFactor?"* opacity":""};`}`),g}const u=Object.freeze(Object.defineProperty({__proto__:null,CompositingPassParameters:g,build:c},Symbol.toStringTag,{value:"Module"}));e.Compositing=u,e.CompositingPassParameters=g,e.build=c}));
