/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ScreenSpacePass.glsl","../views/3d/webgl-engine/core/shaderModules/IntegerPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform"],(function(e,r,o,s,a,c){"use strict";class l extends s.NoParameters{}function t(){const e=new a.ShaderBuilder;return e.include(r.ScreenSpacePass),e.outputs.add("fragColor","vec4",0),e.fragment.uniforms.add(new c.Texture2DPassUniform("colorTexture",(e=>e.color)),new c.Texture2DPassUniform("focusArea",(e=>e.focusArea)),new o.IntegerPassUniform("focusAreaEffectMode",(e=>e.effect??1))).main.add(s.glsl`float mask = texture( focusArea, uv, 0.0 ).r;
vec4 color = texture( colorTexture, uv, 0.0 );
vec4 colorDeSaturate = vec4(color.r * 0.25 + color.g * 0.5 + color.b * 0.25);
if (focusAreaEffectMode == 1) {
fragColor = mask > 0.0 ? color : 0.55 * colorDeSaturate + 0.45;
} else {
fragColor = mask > 0.0 ? color : 0.33 * mix(color, colorDeSaturate, 0.);
}`),e}const n=Object.freeze(Object.defineProperty({__proto__:null,FocusAreaColorPassParameters:l,build:t},Symbol.toStringTag,{value:"Module"}));e.FocusAreaColor=n,e.FocusAreaColorPassParameters=l,e.build=t}));
