/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ScreenSpacePass.glsl","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform"],(function(e,s,i,n,r,t){"use strict";function a(e){const a=new r.ShaderBuilder;return a.include(s.ScreenSpacePass),a.fragment.uniforms.add(new t.Texture2DPassUniform("densityMap",(e=>e.densityMap)),new t.Texture2DPassUniform("tex",(e=>e.colorRamp)),new i.FloatPassUniform("densityNormalizer",(e=>1/(e.maxDensity-e.minDensity))),new i.FloatPassUniform("minDensity",(e=>e.minDensity)),new i.FloatPassUniform("densityMultiplier",(s=>3/(s.searchRadius*s.searchRadius*Math.PI)*(e.usesHalfFloat?4:1)))).main.add(n.glsl`float density = texture(densityMap, uv).r * densityMultiplier;
float densityRatio = (density - minDensity) * densityNormalizer;
fragColor = texture(tex, vec2(clamp(densityRatio, 0.0, 1.0), 0.5));`),a}const o=Object.freeze(Object.defineProperty({__proto__:null,build:a},Symbol.toStringTag,{value:"Module"}));e.Heatmap=o,e.build=a}));
