/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/HighlightCellGridScreenSpacePass.glsl","../views/3d/webgl-engine/core/shaderLibrary/HighlightReadBitmap.glsl","../views/3d/webgl-engine/core/shaderModules/IntegerPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform"],(function(e,i,l,g,t,h,r){"use strict";function n(){const e=new h.ShaderBuilder;e.include(i.HighlightCellGridScreenSpacePass),e.include(l.HighlightReadBitmap);const{fragment:n}=e;return e.outputs.add("fragSingleHighlight","vec2",0),n.uniforms.add(new r.Texture2DPassUniform("highlightTexture",(e=>e.highlightTexture)),new g.IntegerPassUniform("maxHighlightLevel",(e=>e.maxHighlightLevel)),new g.IntegerPassUniform("highlightLevel",(e=>e.highlightLevel))),e.include(l.HighlightReadBitmap),n.main.add(t.glsl`ivec2 iuv = ivec2(gl_FragCoord.xy);
vec2 inputTexel = texelFetch(highlightTexture, iuv, 0).rg;
uint bits = readLevelBits(inputTexel, highlightLevel);
bool hasHighlight = (bits & 1u) == 1u;
bool hasOccluded  = (bits & 2u) == 2u;
fragSingleHighlight = vec2(hasHighlight ? 1.0 : 0.0, hasOccluded ? 1.0 : 0.0);`),e}const s=Object.freeze(Object.defineProperty({__proto__:null,build:n},Symbol.toStringTag,{value:"Module"}));e.HighlightToSingle=s,e.build=n}));
