/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/Transform.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VertexColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/output/OutputHighlight.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/AlphaCutoff","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/Float4PassUniform","../views/3d/webgl-engine/core/shaderModules/FloatPassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/lib/VertexAttribute"],(function(e,r,o,i,l,t,a,s,n,d,g,u,c){"use strict";function w(e){const w=new u.ShaderBuilder,{vertex:h,fragment:b}=w;return w.include(i.Transform,e),w.include(l.VertexColor,e),s.addProjViewLocalOrigin(h,e),w.attributes.add(c.VertexAttribute.POSITION,"vec3"),w.varyings.add("vpos","vec3"),h.main.add(g.glsl`vpos = position;
forwardNormalizedVertexColor();
gl_Position = transformPosition(proj, view, vpos);`),w.include(t.OutputHighlight,e),w.include(o.SliceDraw,e),b.uniforms.add(new d.FloatPassUniform("alphaCoverage",((e,r)=>Math.min(1,e.width*r.camera.pixelRatio)))),e.hasVertexColors||b.uniforms.add(new n.Float4PassUniform("constantColor",(e=>e.color))),b.main.add(g.glsl`
    discardBySlice(vpos);

    vec4 color = ${e.hasVertexColors?"vColor":"constantColor"};

    ${e.output===r.ShaderOutput.ObjectAndLayerIdColor?"color.a = 1.0;":""}

    if (color.a < ${g.glsl.float(a.alphaCutoff)}) {
      discard;
    }

    ${e.output===r.ShaderOutput.Color?g.glsl`fragColor = highlightSlice(color, vpos);`:""}
    calculateOcclusionAndOutputHighlight();
  `),w}const h=Object.freeze(Object.defineProperty({__proto__:null,build:w},Symbol.toStringTag,{value:"Module"}));e.NativeLine=h,e.build=w}));
