/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/libs/gl-matrix-2/factories/vec2f64","../views/3d/webgl-engine/core/shaderLibrary/HighlightCellGridScreenSpacePass.glsl","../views/3d/webgl-engine/core/shaderModules/Float2DrawUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DDrawUniform"],(function(e,r,i,u,l,t,n){"use strict";class g extends l.NoParameters{constructor(){super(...arguments),this.blurSize=r.create()}}function s(){const e=new t.ShaderBuilder;return e.include(i.HighlightCellGridScreenSpacePass),e.fragment.uniforms.add(new u.Float2DrawUniform("blurSize",(e=>e.blurSize)),new n.Texture2DDrawUniform("blurInput",(e=>e.blurInput))),e.outputs.add("fragSingleHighlight","vec2",0),e.fragment.main.add(l.glsl`vec2 highlightTextureSize = vec2(textureSize(blurInput,0));
vec2 uv = sUV;
vec2 center = texture(blurInput, uv).rg;
if (vOutlinePossible == 0.0) {
fragSingleHighlight = center;
} else {
vec2 sum = center * 0.204164;
sum += texture(blurInput, uv + blurSize * 1.407333).rg * 0.304005;
sum += texture(blurInput, uv - blurSize * 1.407333).rg * 0.304005;
sum += texture(blurInput, uv + blurSize * 3.294215).rg * 0.093913;
sum += texture(blurInput, uv - blurSize * 3.294215).rg * 0.093913;
fragSingleHighlight = sum;
}`),e}const a=Object.freeze(Object.defineProperty({__proto__:null,SingleHighlightBlurDrawParameters:g,build:s},Symbol.toStringTag,{value:"Module"}));e.SingleHighlightBlur=a,e.SingleHighlightBlurDrawParameters=g,e.build=s}));
