/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../../core/deprecate","../../core/Logger","../../core/promiseUtils","../Mesh","./meshUtils/georeference","./meshUtils/merge"],(function(e,r,t,n,o,s,c,i){"use strict";const a=()=>n.getLogger("esri.geometry.support.meshUtils");async function l(r,t,n){const s=await new Promise(((r,t)=>e(["./meshUtils/elevation"],r,t)));return o.throwIfAborted(n),s.create(r,t,n)}async function p(r,t){await r.load();return(await new Promise(((r,t)=>e(["./meshUtils/elevationSampler"],r,t)))).create(r,t)}function m(e,r,n){return t.deprecatedFunction(a(),"`meshUtils.georeference` is deprecated in favor of 'meshUtils.convertVertexSpace'",{replacement:"meshUtils.convertVertexSpace",version:"4.30",see:"https://developers.arcgis.com/javascript/latest/api-reference/esri-geometry-support-meshUtils.html#convertVertexSpace",warnOnce:!0}),c.georeference(e,r,n)}function u(e,r,n){return t.deprecatedFunction(a(),"`meshUtils.ungeoreference` is deprecated in favor of 'meshUtils.convertVertexSpace'",{replacement:"meshUtils.convertVertexSpace",version:"4.30",see:"https://developers.arcgis.com/javascript/latest/api-reference/esri-geometry-support-meshUtils.html#convertVertexSpace",warnOnce:!0}),c.ungeoreference(e,r,n)}function f(e){const r=i.merge(e);return null!=r?new s(r):null}async function h(r,t,n){const{convertMeshVertexSpace:s}=await new Promise(((r,t)=>e(["./meshUtils/convertMeshVertexSpace"],r,t)));return o.throwIfAborted(n),s(r,t,n)}r.convertVertexSpace=h,r.createElevationSampler=p,r.createFromElevation=l,r.georeference=m,r.merge=f,r.ungeoreference=u,Object.defineProperty(r,Symbol.toStringTag,{value:"Module"})}));
