/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../chunks/tslib.es6","../request","../core/Error","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./Layer","./mixins/BlendLayer","./mixins/RefreshableLayer","./mixins/ScaleRangeLayer"],(function(e,a,t,r,s,o,i,n,c,m,y,p){"use strict";var g;let l=g=class extends(m.BlendLayer(p.ScaleRangeLayer(y.RefreshableLayer(c)))){constructor(){super(...arguments),this.type="base-dynamic"}getImageUrl(){throw new t("basedynamiclayer:getImageUrl-not-implemented","getImageUrl() is not implemented")}async fetchImage(e,t,r,s){const o=this.getImageUrl(e,t,r),i={responseType:"image",signal:s?.signal,query:{...this.refreshParameters}};if("string"==typeof o){const{data:e}=await a(o,i);return e}const n=await o,{data:c}=await a(n,i);return c}async fetchImageBitmap(e,r,s,o={}){if(this.fetchImage!==g.prototype.fetchImage){const a=await this.fetchImage(e,r,s,o);try{return await createImageBitmap(a)}catch(y){throw new t("request:server","Unable to load image",{error:y,extent:e,width:r,height:s})}}const i=this.getImageUrl(e,r,s),n={responseType:"blob",signal:o?.signal,query:{...this.refreshParameters}};if("string"==typeof i){const{data:e}=await a(i,n);return createImageBitmap(e)}const c=await i,{data:m}=await a(c,n);return createImageBitmap(m)}};e.__decorate([r.property({readOnly:!0,value:"base-dynamic"})],l.prototype,"type",void 0),e.__decorate([r.property({type:["show","hide"]})],l.prototype,"listMode",void 0),l=g=e.__decorate([n.subclass("esri.layers.BaseDynamicLayer")],l);return l}));
