/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/Logger","../ClassBreaksRenderer","../DictionaryRenderer","../DotDensityRenderer","../HeatmapRenderer","../PieChartRenderer","../Renderer","../SimpleRenderer","../UniqueValueRenderer"],(function(e,r,n,t,s,a,o,i,l,u){"use strict";const p={key:"type",base:i,typeMap:{heatmap:a,simple:l,"unique-value":u,"class-breaks":n,"dot-density":s,dictionary:t,"pie-chart":o},errorContext:"renderer"},c={key:"type",base:i,typeMap:{simple:l,"unique-value":u,"class-breaks":n,heatmap:a},errorContext:"renderer",validate:d};function d(e){switch(e.type){case"simple":return y(e);case"unique-value":return m(e);case"class-breaks":return b(e);case"heatmap":return e}}function y(e){if(e.symbol)return e;r.getLogger("esri.renderers.support.types").error("Removed invalid 'simple' renderer without a symbol from web scene.")}function m(e){const n=e.uniqueValueInfos,t=n?.filter((({symbol:e,label:n},t)=>(e||r.getLogger("esri.renderers.support.types").error(`Removed invalid unique value info ([${t}] ${n}) without a symbol from web scene.`),!!e)));return t?.length!==n?.length&&(e.uniqueValueInfos=t),e}function b(e){const n=e.classBreakInfos,t=n?.filter((({symbol:e,label:n},t)=>(e||r.getLogger("esri.renderers.support.types").error(`Removed invalid class break info ([${t}] ${n}) without a symbol from web scene.`),!!e)));return t?.length!==n?.length&&(e.classBreakInfos=t),e}e.rendererTypes=p,e.webSceneRendererTypes=c,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
