/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../chunks/tslib.es6","../core/Accessor","../core/accessorSupport/decorators/property","../core/has","../core/Logger","../core/RandomLCG","../core/accessorSupport/decorators/subclass","./OperationStatus","./UndoRedoError"],(function(t,e,o,r,a,n,s,d,i,p){"use strict";var u;t.UndoRedoExecutionMethod=void 0,(u=t.UndoRedoExecutionMethod||(t.UndoRedoExecutionMethod={}))[u.Apply=0]="Apply",u[u.Undo=1]="Undo",u[u.Redo=2]="Redo",t.UndoableOperation=class extends o{constructor(){super(...arguments),this.name="",this.tag=Symbol(),this.status=i.OperationStatus.NeverApplied}get canUndo(){return this.status===i.OperationStatus.Applied}get canRedo(){return this.status===i.OperationStatus.Undone}async executeUndoRedoOperation(e){switch(e){case t.UndoRedoExecutionMethod.Apply:if(this.status!==i.OperationStatus.NeverApplied)throw new p.ApplyInvalidError;return await this.apply(),void(this.status=i.OperationStatus.Applied);case t.UndoRedoExecutionMethod.Undo:if(this.status!==i.OperationStatus.Applied)throw new p.UndoInvalidError;return await this.undo(),void(this.status=i.OperationStatus.Undone);case t.UndoRedoExecutionMethod.Redo:if(this.status!==i.OperationStatus.Undone)throw new p.UndoInvalidError;return await this.redo(),void(this.status=i.OperationStatus.Applied)}}},e.__decorate([r.property()],t.UndoableOperation.prototype,"name",void 0),e.__decorate([r.property()],t.UndoableOperation.prototype,"tag",void 0),t.UndoableOperation=e.__decorate([d.subclass("esri.undoredo.UndoableOperation")],t.UndoableOperation),Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
