/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","./DictionaryMatcher","./IntervalMatcher","./LabelMatcher","./MapMatcher","./Matcher"],(function(e,t,r,a,c,s){"use strict";async function n(e,n){switch(n.type){case"simple":case"heatmap":case"dot-density":case"pie-chart":return s.FeatureMatcher.from(e,n);case"interval":return r.IntervalMatcher.fromIntervalSchema(e,n);case"dictionary":return t.DictionaryMatcher.fromDictionaryRenderer(e,n);case"label":return a.LabelMatcher.fromLabelSchema(e,n);case"map":return c.MapMatcher.fromMatcherSchema(e,n);case"subtype":return u.fromSubtypes(e,n);case"cluster":return h.fromClusterSchema(e,n);default:throw new Error("Impl")}}class u extends s.FeatureMatcher{constructor(e,t){super(),this._subMatchers=e,this._subtypeField=t}static async fromSubtypes(e,t){const r=new Map,a=[];for(const c in t.renderers){const s=parseInt(c,10),u=n(e,t.renderers[c]).then((e=>r.set(s,e)));a.push(u)}return await Promise.all(a),new u(r,t.subtypeField)}match(e,t){const r=e.readAttribute(this._subtypeField),a=this._subMatchers.get(r);return a?a.match(e,t):null}}class h extends s.FeatureMatcher{static async fromClusterSchema(e,t){const[r,a]=await Promise.all([n(e,t.feature),n(e,t.cluster)]);return new h(r,a)}constructor(e,t){super(),this._featureMatcher=e,this._clusterMatcher=t}match(e,t){return 1===e.readAttribute("cluster_count")?this._featureMatcher.match(e,t):this._clusterMatcher.match(e,t)}}e.ClusterMatcher=h,e.SubtypeMatcher=u,e.createMatcher=n,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
