/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/mathUtils","../../../geometry/ellipsoidUtils","../../../geometry/Point"],(function(t,e,n,o){"use strict";function i(t,e,n){if(null==e.longitude||null==e.latitude||null==n.longitude||null==n.latitude)throw new Error("Invalid points: no lon/lat");return r(t,e.longitude,e.latitude,n.longitude,n.latitude)}function r(t,n,o,i,r){const u=e.deg2rad(o),s=e.deg2rad(r),a=u-s,l=e.deg2rad(n)-e.deg2rad(i),d=Math.sin(a/2),c=Math.sin(l/2),g=2*e.asinClamped(Math.sqrt(d*d+Math.cos(u)*Math.cos(s)*c*c))*t;return Math.round(1e4*g)/1e4}function u(t,e,r){const u=e.spatialReference,s=n.getReferenceEllipsoid(u),a=new o(e.x,t.y,u),l=new o(r.x,t.y,u),d=new o(t.x,e.y,u),c=new o(t.x,r.y,u);return{lon:i(s.radius,a,l),lat:i(s.radius,d,c)}}function s(t,n,o){const i=n/o,r=e.deg2rad(t),u=Math.sin(i/2),s=Math.cos(r),a=2*e.asinClamped(Math.sqrt(u*u/(s*s)));return e.rad2deg(a)}function a(t,e){let n=t/15;return e||(n=Math.round(n)),n}function l(t,e){const n=t?.[0];if(null==n)return null;e||(e={hours:0,minutes:0,seconds:0}),e.hours=a(n,!0);const o=e.hours%1;e.hours-=o,e.minutes=60*o;const i=e.minutes%1;return e.minutes-=i,e.seconds=Math.round(60*i),e}t.getGreatCircleDistance=r,t.getGreatCircleDistanceFromPoints=i,t.getGreatCircleSpanAt=u,t.getLonDeltaForDistance=s,t.longitudeToTimezone=a,t.positionToTimezoneInfo=l,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
