/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../ShaderOutput","../attributes/VertexTextureCoordinates.glsl","../../shaderModules/Float3DrawUniform","../../shaderModules/Float3PassUniform","../../shaderModules/interfaces","../../shaderModules/Texture2DDrawUniform","../../shaderModules/Texture2DPassUniform","../../shaderTechnique/BindType","../../../lib/GLTextureMaterial"],(function(e,s,i,o,r,n,t,a,u,m){"use strict";var d;e.EmissionSource=void 0,(d=e.EmissionSource||(e.EmissionSource={}))[d.None=0]="None",d[d.Value=1]="Value",d[d.Texture=2]="Texture",d[d.COUNT=3]="COUNT";class c extends m.GLEmissiveTexturePassParameters{}function l(m,d){if(!s.isColorOrColorEmission(d.output))return;const{emissionSource:c,hasEmissiveTextureTransform:l,bindType:x}=d,f=c===e.EmissionSource.Texture;f&&(m.include(i.VertexTextureCoordinates,d),m.fragment.uniforms.add(x===u.BindType.Pass?new a.Texture2DPassUniform("texEmission",(e=>e.textureEmissive)):new t.Texture2DDrawUniform("texEmission",(e=>e.textureEmissive))));const T=c===e.EmissionSource.Value||f;T&&m.fragment.uniforms.add(x===u.BindType.Pass?new r.Float3PassUniform("emissionFactor",(e=>e.emissiveFactor)):new o.Float3DrawUniform("emissionFactor",(e=>e.emissiveFactor))),m.fragment.code.add(n.glsl`
    vec4 getEmissions() {
      vec4 emissions = ${T?"vec4(emissionFactor, 1.0)":"vec4(0.0)"};
      ${n.If(f,`emissions *= textureLookup(texEmission, ${l?"emissiveUV":"vuv0"});\n         emissions.w = emissions.rgb == vec3(0.0) ? 0.0: emissions.w;`)};
      return emissions;
    }
  `)}e.Emissions=l,e.EmissionsParameters=c,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
