/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../../core/compilerUtils","../attributes/NormalAttribute.glsl","../attributes/VertexNormal.glsl","../attributes/VertexPosition.glsl","./Normals.glsl","../../shaderModules/interfaces"],(function(e,a,o,r,l,d,i){"use strict";function t(e,t){const n=e.fragment;switch(t.doubleSidedMode){case d.NormalsDoubleSidedMode.None:n.code.add(i.glsl`vec3 _adjustDoublesided(vec3 normal) {
return normal;
}`);break;case d.NormalsDoubleSidedMode.View:e.include(l.VertexPosition,t),n.code.add(i.glsl`vec3 _adjustDoublesided(vec3 normal) {
return dot(normal, vPositionWorldCameraRelative) > 0.0 ? -normal : normal;
}`);break;case d.NormalsDoubleSidedMode.WindingOrder:n.code.add(i.glsl`vec3 _adjustDoublesided(vec3 normal) {
return gl_FrontFacing ? normal : -normal;
}`);break;default:a.neverReached(t.doubleSidedMode);case d.NormalsDoubleSidedMode.COUNT:}switch(t.normalType){case o.NormalType.Attribute:case o.NormalType.Compressed:e.include(r.VertexNormal,t),n.main.add(i.glsl`vec3 fragmentFaceNormal = _adjustDoublesided(normalize(vNormalWorld));
vec3 fragmentFaceNormalView = gl_FrontFacing ? normalize(vNormalView) : -normalize(vNormalView);`);break;case o.NormalType.ScreenDerivative:e.include(l.VertexPosition,t),n.main.add(i.glsl`vec3 fragmentFaceNormal = normalize(cross(dFdx(vPositionWorldCameraRelative), dFdy(vPositionWorldCameraRelative)));
vec3 fragmentFaceNormalView = normalize(cross(dFdx(vPosition_view), dFdy(vPosition_view)));`);default:case o.NormalType.COUNT:}t.shadeNormals?n.main.add(i.glsl`vec3 fragmentShadingNormal = fragmentFaceNormal;`):t.spherical?(e.include(l.VertexPosition,t),n.main.add(i.glsl`vec3 fragmentShadingNormal = normalize(positionWorld());`)):n.main.add(i.glsl`vec3 fragmentShadingNormal = vec3(0.0, 0.0, 1.0);`)}e.computeFragmentNormals=t,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
