/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","./AlphaCutoff","../../shaderModules/FloatDrawUniform","../../shaderModules/FloatPassUniform","../../shaderModules/interfaces","../../../lib/basicInterfaces"],(function(a,e,d,o,r,s){"use strict";function l(a,e){c(a,e,new o.FloatPassUniform("textureAlphaCutoff",(a=>a.textureAlphaCutoff)))}function t(a,e){c(a,e,new d.FloatDrawUniform("textureAlphaCutoff",(a=>a.textureAlphaCutoff)))}function c(a,d,o){const l=a.fragment;switch(d.alphaDiscardMode){case s.AlphaDiscardMode.Blend:a.fragment.code.add(r.glsl`
        #define discardOrAdjustAlpha(color) { if (color.a < ${r.glsl.float(e.alphaCutoff)}) { discard; } }
      `);break;case s.AlphaDiscardMode.Opaque:l.code.add(r.glsl`void discardOrAdjustAlpha(inout vec4 color) {
color.a = 1.0;
}`);break;case s.AlphaDiscardMode.Mask:l.uniforms.add(o).code.add(r.glsl`#define discardOrAdjustAlpha(color) { if (color.a < textureAlphaCutoff) { discard; } else { color.a = 1.0; } }`);break;case s.AlphaDiscardMode.MaskBlend:l.uniforms.add(o).code.add(r.glsl`#define discardOrAdjustAlpha(color) { if (color.a < textureAlphaCutoff) { discard; } }`)}}a.DiscardOrAdjustAlphaDraw=t,a.DiscardOrAdjustAlphaPass=l,Object.defineProperty(a,Symbol.toStringTag,{value:"Module"})}));
