/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../core/shaderLibrary/ShaderOutput","../core/shaderModules/interfaces","../core/shaderTechnique/ReloadableShaderModule","../core/shaderTechnique/ShaderTechnique","../lib/OITPass","../lib/OrderIndependentTransparency","../lib/StencilUtils","../lib/VertexAttribute","../../../../chunks/ImageMaterial.glsl","../../../webgl/renderState"],(function(e,t,r,i,l,a,s,n,u,o,c,d){"use strict";class h extends i.NoParameters{}class p extends a.ShaderTechnique{constructor(t,r,i){super(t,r,new l.ReloadableShaderModule(c.ImageMaterial,(()=>new Promise(((t,r)=>e(["./ImageMaterial.glsl"],t,r))))),i,P)}_getPipelineState(e,t){const{oitPass:i,output:l,hasOccludees:a,enableOffset:o,cullFace:c}=e,h=i===s.OITPass.NONE,p=i===s.OITPass.FrontFace;return d.makePipelineState({blending:l===r.ShaderOutput.Color?h?d.blendWithPremultipliedAlpha:n.oitBlending(i):null,culling:d.cullingParams(c),depthTest:{func:n.oitDepthTest(i)},depthWrite:n.depthWrite(e),drawBuffers:n.getDrawBuffers(i,l),colorWrite:d.defaultColorWrite,stencilWrite:a?u.stencilWriteMaskOn:null,stencilTest:a?t?u.stencilToolMaskBaseParams:u.stencilBaseAllZerosParams:null,polygonOffset:h||p?null:n.getOITPolygonOffset(o)})}initializePipeline(e){return this._occludeePipeline=this._getPipelineState(e,!0),this._getPipelineState(e,!1)}getPipeline(e){return e?this._occludeePipeline:super.getPipeline()}}const P=new Map([[o.VertexAttribute.POSITION,0],[o.VertexAttribute.UV0,2],[o.VertexAttribute.PERSPECTIVEDIVIDE,3]]);t.ImageMaterialPassParameters=h,t.ImageMaterialTechnique=p,t.vertexAttributeLocations=P,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
