/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ShaderOutput","../views/3d/webgl-engine/core/shaderLibrary/Slice.glsl","../views/3d/webgl-engine/core/shaderLibrary/Transform.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/ObjectAndLayerIdColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/attributes/VertexColor.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/TerrainDepthTest.glsl","../views/3d/webgl-engine/core/shaderLibrary/shading/VisualVariables.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/ColorConversion.glsl","../views/3d/webgl-engine/core/shaderLibrary/util/View.glsl","../views/3d/webgl-engine/core/shaderModules/Float4PassUniform","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/lib/VertexAttribute","../views/3d/webgl-engine/shaders/OutputColorHighlightOID.glsl"],(function(e,r,o,i,l,t,s,d,a,n,g,u,c,b,v){"use strict";function w(e){const w=new c.ShaderBuilder,{vertex:h,fragment:C,attributes:p,varyings:f}=w;n.addProjViewLocalOrigin(h,e),w.include(i.Transform,e),w.include(t.VertexColor,e),w.include(d.VisualVariables,e),w.include(l.ObjectAndLayerIdColor,e),w.include(o.SliceDraw,e),w.include(v.outputColorHighlightOID,e),p.add(b.VertexAttribute.POSITION,"vec3"),e.vvColor&&p.add(b.VertexAttribute.COLORFEATUREATTRIBUTE,"float"),f.add("vColor","vec4"),f.add("vpos","vec3");const y=e.terrainDepthTest&&e.output===r.ShaderOutput.Color;return y&&f.add("depth","float"),h.uniforms.add(new g.Float4PassUniform("eColor",(e=>e.color))),h.main.add(u.glsl`
      vpos = position;
      forwardNormalizedVertexColor();
      forwardObjectAndLayerIdColor();

      ${e.hasVertexColors?"vColor *= eColor;":e.vvColor?"vColor = eColor * interpolateVVColor(colorFeatureAttribute);":"vColor = eColor;"}
      ${y?"depth = (view * vec4(vpos, 1.0)).z;":""}
      gl_Position = transformPosition(proj, view, vpos);`),w.include(o.SliceDraw,e),y&&w.include(s.terrainDepthTest,e),C.include(a.ColorConversion),C.main.add(u.glsl`
    discardBySlice(vpos);
    ${y?"terrainDepthTest(depth);":""}
    vec4 fColor = vColor;
    outputColorHighlightOID(fColor, vpos);`),w}const h=Object.freeze(Object.defineProperty({__proto__:null,build:w},Symbol.toStringTag,{value:"Module"}));e.ColorMaterial=h,e.build=w}));
