/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../views/3d/webgl-engine/core/shaderLibrary/ScreenSpacePass.glsl","../views/3d/webgl-engine/core/shaderModules/interfaces","../views/3d/webgl-engine/core/shaderModules/ShaderBuilder","../views/3d/webgl-engine/core/shaderModules/Texture2DPassUniform"],(function(e,r,a,s,o){"use strict";class t extends a.NoParameters{}function n(){const e=new s.ShaderBuilder;return e.include(r.ScreenSpacePass),e.fragment.uniforms.add(new o.Texture2DPassUniform("colorTexture",(e=>e.colorTexture)),new o.Texture2DPassUniform("alphaTexture",(e=>e.alphaTexture)),new o.Texture2DPassUniform("frontFaceTexture",(e=>e.frontFaceTexture))).main.add(a.glsl`float srcAlpha = texture(alphaTexture, uv).r;
if(srcAlpha == 0.0){
fragColor = vec4(0.0);
return;
}
vec4 srcColor = texture(colorTexture, uv);
vec4 frontFace = texture(frontFaceTexture, uv);
fragColor = vec4(mix(srcColor.rgb / srcAlpha, frontFace.rgb, frontFace.a), 1.0 - srcColor.a);`),e}const l=Object.freeze(Object.defineProperty({__proto__:null,OITBlendPassParameters:t,build:n},Symbol.toStringTag,{value:"Module"}));e.OITBlend=l,e.OITBlendPassParameters=t,e.build=n}));
