/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","./support/Ellipsoid","./support/spatialReferenceUtils"],(function(e,n,r){"use strict";function i(e){return{wkt:`GEOCCS["Spherical geocentric",\n    DATUM["Not specified",\n      SPHEROID["Sphere",${e.radius},0]],\n    PRIMEM["Greenwich",0.0,\n      AUTHORITY["EPSG","8901"]],\n    UNIT["m",1.0],\n    AXIS["Geocentric X",OTHER],\n    AXIS["Geocentric Y",EAST],\n    AXIS["Geocentric Z",NORTH]\n  ]`}}const t=i(n.earth),o=i(n.mars),c=i(n.moon),s={wkt:`GEOCCS["WGS 84",\n  DATUM["WGS_1984",\n    SPHEROID["WGS 84",${n.earth.radius},298.257223563,\n      AUTHORITY["EPSG","7030"]],\n    AUTHORITY["EPSG","6326"]],\n  PRIMEM["Greenwich",0,\n    AUTHORITY["EPSG","8901"]],\n  UNIT["m",1.0,\n    AUTHORITY["EPSG","9001"]],\n  AXIS["Geocentric X",OTHER],\n  AXIS["Geocentric Y",OTHER],\n  AXIS["Geocentric Z",NORTH],\n  AUTHORITY["EPSG","4978"]\n]`},a=o.wkt.toUpperCase(),S=c.wkt.toUpperCase();function p(e){if(null!=e&&r.isValid(e)){const i=e.wkid,t=e.wkt2??e.wkt;if(r.isWKIDFromMars(i))return n.mars;const o=t?.toUpperCase();if(t&&o===a)return n.mars;if(r.isWKIDFromMoon(i)||o&&o===S)return n.moon}return n.earth}function l(e){return r.isWKIDFromMars(e)?n.mars:r.isWKIDFromMoon(e)?n.moon:n.earth}function u(e){return r.equals(e,t)}function E(e){return u(e)||r.equals(e,o)||r.equals(e,c)}e.SphericalECEFSpatialReferenceLike=t,e.SphericalPCPFMarsLike=o,e.SphericalPCPFMoonLike=c,e.WGS84ECEFSpatialReferenceLike=s,e.getReferenceEllipsoid=p,e.getReferenceEllipsoidFromWKID=l,e.isSphericalECEF=u,e.isSphericalPCPF=E,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
