/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../core/Error","../../core/Logger","./LabelClass"],(function(e,o,r,t){"use strict";const n=()=>r.getLogger("esri.layers.support.labelingInfo"),l=/\[([^[\]]+)\]/gi;function i(e,o,r){return e?e.map((e=>{const n=new t;if(n.read(e,r),n.labelExpression){const e=o.fields||o.layerDefinition?.fields||this.fields;n.labelExpression=n.labelExpression.replaceAll(l,((o,r)=>`[${s(r,e)}]`))}return n})):null}function s(e,o){if(!o)return e;const r=e.toLowerCase();for(let t=0;t<o.length;t++){const e=o[t].name;if(e.toLowerCase()===r)return e}return e}const a={esriGeometryPoint:["above-right","above-center","above-left","center-center","center-left","center-right","below-center","below-left","below-right"],esriGeometryMultiPatch:["always-horizontal"],esriGeometryPolygon:["always-horizontal"],esriGeometryPolyline:["center-along","above-along","below-along"],esriGeometryMultipoint:null,esriGeometryEnvelope:null};function c(e,r){const t=[];for(const l of e){const e=l.labelPlacement,i=a[r];if(!l.symbol)return n().warn("No ILabelClass symbol specified."),[];if(!i)return n().error(new o("labeling:unsupported-geometry-type",`Unable to create labels for layer, geometry type '${r}' is not supported`)),[];if(i.includes(e))t.push(l);else{const o=i[0];e&&n().warn(`Found invalid label placement type ${e} for ${r}. Defaulting to ${o}`);const s=l.clone();s.labelPlacement=o,t.push(s)}}return t}e.reader=i,e.validateLabelingInfo=c,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
