/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../chunks/tslib.es6","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","./BaseRasterFunction","./TableFunctionArguments"],(function(e,t,r,s,o,n,i,c){"use strict";let a=class extends i{constructor(){super(...arguments),this.functionName="Table",this.functionArguments=null,this.rasterArgumentNames=["raster"],this.isNoopProcess=!0}_bindSourceRasters(){const e=this.sourceRasterInfos[0];if(e.bandCount>1||e.pixelType.startsWith("f"))return{success:!1,supportsGPU:!1,error:"table-function: Source data must be single band and integer pixel type."};const{attributeTableAsRecordSet:t}=this.functionArguments;if(!t)return{success:!1,supportsGPU:!1,error:"table-function: Missing attributeTableAsRecordSet argument."};this.outputPixelType=this._getOutputPixelType(e.pixelType);const r=e.clone();return r.pixelType=this.outputPixelType,r.bandCount=1,"thematic"!==r.dataType&&(r.keyProperties=r.keyProperties?{...r.keyProperties,DataType:"thematic"}:{DataType:"thematic"}),this.rasterInfo=r,{success:!0,supportsGPU:!0}}_processPixels(e){return e.pixelBlocks?.[0]}};e.__decorate([t.property({json:{write:!0,name:"rasterFunction"}})],a.prototype,"functionName",void 0),e.__decorate([t.property({type:c,json:{write:!0,name:"rasterFunctionArguments"}})],a.prototype,"functionArguments",void 0),e.__decorate([t.property()],a.prototype,"rasterArgumentNames",void 0),e.__decorate([t.property()],a.prototype,"isNoopProcess",void 0),a=e.__decorate([n.subclass("esri.layers.support.rasterFunctions.TableFunction")],a);return a}));
