/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["../../../../core/Error","../../../../core/Logger","../../../../core/reactiveUtils","../../../../core/libs/gl-matrix-2/factories/mat3f32","../DisplayObject","./Mesh2D","../../support/clippingUtils","../../../webgl/VertexArrayObject"],(function(e,t,s,r,i,c,a,h){"use strict";class n extends i.DisplayObject{constructor(e,t){super(),this._clip=t,this._cache={},this.stage=e,this._handle=s.watch((()=>t.version),(()=>this._invalidate())),this.ready()}static fromClipArea(e,t){return new n(e,t)}_destroyGL(){null!=this._cache.mesh&&(this._cache.mesh.destroy(),this._cache.mesh=null),null!=this._cache.vao&&(this._cache.vao.dispose(),this._cache.vao=null)}destroy(){this._destroyGL(),this._handle.remove()}getVAO(e,t,s,r){const[i,c]=t.size;if("geometry"!==this._clip.type&&this._lastWidth===i&&this._lastHeight===c||(this._lastWidth=i,this._lastHeight=c,this._destroyGL()),null==this._cache.vao){const i=this._createMesh(t,this._clip),c=i.getIndexBuffer(e),a=i.getVertexBuffers(e);this._cache.mesh=i,this._cache.vao=new h.VertexArrayObject(e,s,r,a,c)}return this._cache.vao}_createTransforms(){return{displayViewScreenMat3:r.create()}}_invalidate(){this._destroyGL(),this.requestRender()}_createMesh(s,r){switch(r.type){case"rect":return c.fromScreenExtent(a.createScreenExtent(r,s.size[0],s.size[1]));case"path":return c.fromPath(r);case"geometry":return c.fromGeometry(s,r);default:return t.getLogger("esri.views.2d.engine.webgl.ClippingInfo").error(new e("mapview-bad-type","Unable to create ClippingInfo mesh from clip of type: ${clip.type}")),c.fromScreenExtent({xmin:0,ymin:0,xmax:1,ymax:1})}}}return n}));
