/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../geometry","../../../Viewpoint","../../../core/mathUtils","../../../geometry/support/pointUtils","../viewpointUtils","../../../geometry/Point"],(function(e,t,o,i,r,n,s){"use strict";class a{constructor(e){this._view=e,this.viewpoint=new o({targetGeometry:new s,scale:0,rotation:0})}get view(){return this._view}get size(){const[e,t]=this._view.size;return Math.sqrt(e*e+t*t)}get scale(){return this.viewpoint.scale}get rotation(){return this.viewpoint.rotation}get center(){return this.viewpoint.targetGeometry}get scaleToResolutionFactor(){return n.getScaleToResolutionFactor(this.center.spatialReference)}pixelsPerPanAtZoom(e){return 1/(e*this.scaleToResolutionFactor)}zoomAtPixelsPerPan(e){return 1/(e*this.scaleToResolutionFactor)}pixelsPerRotate(){return this.size/2}compareTo(e,t){t.pan=r.distance(this.center,e.center);let o=Math.abs(e.rotation-this.rotation);o=o>=180?360-o:o,t.rotate=i.deg2rad(o),t.sourceZoom=this.scale,t.targetZoom=e.scale}interpolate(e,t,o){const{pan:r,rotate:n,zoom:s,zoomOffset:a}=o,{center:c}=this;c.spatialReference=e.center.spatialReference,c.x=i.lerp(e.center.x,t.center.x,r),c.y=i.lerp(e.center.y,t.center.y,r),this.viewpoint.scale=i.lerp(e.scale,t.scale+a,s);let l=e.rotation;const p=t.rotation;Math.abs(p-l)>=180&&(l+=360*(l<p?1:-1)),this.viewpoint.rotation=i.lerp(l,p,n)}copyFrom(e){n.copy(this.viewpoint,e.viewpoint),this._view=e.view}}e.Camera=a,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
