/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","./constraintUtils/altitude","./constraintUtils/common","./constraintUtils/ConstraintOptions","./constraintUtils/ConstraintTypes","./constraintUtils/distance","./constraintUtils/InteractionType","./constraintUtils/surfaceCollision","./constraintUtils/tilt","../../animation/easing"],(function(t,n,i,e,o,r,s,a,c,p){"use strict";function l(t,n,e=E,r=n){r!==n&&r.copyFrom(n),r.computeUp(t.state.viewingMode);let s=!1;for(let o=0;o<d;o++){let n=0;for(const o of T)if(i.hasConstraintType(e.selection,o.type)){const i=Math.abs(o.error(t,r,e));o.apply(t,r,e)&&(s=!0,n+=i)}if(0===n)break}const c=i.hasConstraintType(e.selection,o.ConstraintTypes.COLLISION),p=y(e.interactionType,t);return c&&a.applySurfaceCollisionConstraint(t,r,p)&&(s=!0),s&&r.computeUp(t.state.viewingMode),s}function y(t,n){switch(t){case s.InteractionType.PAN:return a.Mode.EYE_AND_CENTER;case s.InteractionType.ASCEND:return n.state.isGlobal?a.Mode.EYE_AND_CENTER_SCALE:a.Mode.EYE_AND_CENTER;default:return a.Mode.EYE}}function C(t){const n=Math.min(1,t/150);return p.inOutCubic(n)}function u(t,n,i){return c.getTiltConstraintError(t,n,i)*n.distance}const T=[{type:o.ConstraintTypes.TILT,error:u,apply:c.applyTiltConstraint},{type:o.ConstraintTypes.ALTITUDE,error:n.getAltitudeConstraintError,apply:n.applyAltitudeConstraint},{type:o.ConstraintTypes.DISTANCE,error:r.getDistanceConstraintError,apply:r.applyDistanceConstraint}],E=new e.ConstraintOptions,d=5;t.applyAll=l,t.pixelDistanceToInteractionFactor=C,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
