/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../../../core/compilerUtils","../../shaderModules/interfaces","../../../lib/VertexAttribute"],(function(e,t,r,d){"use strict";var o;function a(o,a){switch(a.textureCoordinateType){case e.TextureCoordinateType.Default:return o.attributes.add(d.VertexAttribute.UV0,"vec2"),o.varyings.add("vuv0","vec2"),void o.vertex.code.add(r.glsl`void forwardTextureCoordinates() {
vuv0 = uv0;
}`);case e.TextureCoordinateType.Compressed:return o.attributes.add(d.VertexAttribute.UV0,"vec2"),o.varyings.add("vuv0","vec2"),void o.vertex.code.add(r.glsl`vec2 getUV0() {
return uv0 / 16384.0;
}
void forwardTextureCoordinates() {
vuv0 = getUV0();
}`);case e.TextureCoordinateType.Atlas:return o.attributes.add(d.VertexAttribute.UV0,"vec2"),o.varyings.add("vuv0","vec2"),o.attributes.add(d.VertexAttribute.UVREGION,"vec4"),o.varyings.add("vuvRegion","vec4"),void o.vertex.code.add(r.glsl`void forwardTextureCoordinates() {
vuv0 = uv0;
vuvRegion = uvRegion;
}`);default:t.neverReached(a.textureCoordinateType);case e.TextureCoordinateType.None:return void o.vertex.code.add(r.glsl`void forwardTextureCoordinates() {}`);case e.TextureCoordinateType.COUNT:return}}e.TextureCoordinateType=void 0,(o=e.TextureCoordinateType||(e.TextureCoordinateType={}))[o.None=0]="None",o[o.Default=1]="Default",o[o.Atlas=2]="Atlas",o[o.Compressed=3]="Compressed",o[o.COUNT=4]="COUNT",e.TextureCoordinateAttribute=a,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
