/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../shaderModules/Float3PassUniform","../../shaderModules/interfaces"],(function(i,n,t){"use strict";function a(i){i.uniforms.add(new n.Float3PassUniform("mainLightDirection",((i,n)=>n.lighting.mainLight.direction)))}function o(i){i.uniforms.add(new n.Float3PassUniform("mainLightIntensity",((i,n)=>n.lighting.mainLight.intensity)))}function e(i){a(i.fragment),o(i.fragment),i.fragment.code.add(t.glsl`vec3 applyShading(vec3 shadingNormalWorld, float shadow) {
float dotVal = clamp(dot(shadingNormalWorld, mainLightDirection), 0.0, 1.0);
return mainLightIntensity * ((1.0 - shadow) * dotVal);
}`)}i.addMainLightDirection=a,i.addMainLightIntensity=o,i.applyShading=e,Object.defineProperty(i,Symbol.toStringTag,{value:"Module"})}));
