/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../output/ReadDepth.glsl","../../shaderModules/interfaces","../../shaderModules/Texture2DPassUniform"],(function(e,t,r,a){"use strict";function n(e,{occlusionPass:n,terrainDepthTest:i,cullAboveTerrain:l}){i?(e.fragment.include(t.ReadDepth),e.fragment.uniforms.add(new a.Texture2DPassUniform("terrainDepthTexture",((e,t)=>t.terrainDepth?.attachment))).code.add(r.glsl`
   ${n?"bool":"void"} terrainDepthTest(float fragmentDepth) {
      float depth = texelFetch(terrainDepthTexture, ivec2(gl_FragCoord.xy), 0).r;
      float linearDepth = linearizeDepth(depth);
      ${n?r.glsl`return fragmentDepth < linearDepth && depth < 1.0;`:r.glsl`if(fragmentDepth ${l?">":"<="} linearDepth) discard;`}
    }`)):n?e.fragment.code.add(r.glsl`#define terrainDepthTest(fragmentDepth) false`):e.fragment.code.add(r.glsl`#define terrainDepthTest(fragmentDepth) {}`)}e.terrainDepthTest=n,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
