/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/has","../../../../core/NestedMap","../effects/ScreenSpaceGeometry","../materials/renderers/VaoCache","../../../webgl/AppleAmdDriverHelper","../../../webgl/RenderingContext"],(function(e,r,s,t,i,n,a){"use strict";class o extends a.RenderingContext{constructor(e,r){super(e,r),this.gl=e,this._vaoCaches=new s.NestedMap,this._appleAmdDriverHelper=null,this._refCount=1,this._newCache=r.newCache,this.screen=new t.ScreenSpaceGeometry(this)}configure(e){super.configure(e),this._newCache=e.newCache}destroy(){this._vaoCaches?.forAll((e=>e.dispose())),this._vaoCaches?.clear(),--this._refCount>0||this.dispose()}ref(){++this._refCount}dispose(){super.dispose(),this._appleAmdDriverHelper?.dispose(),this.screen.destroy(),this._vaoCaches.forAll((e=>e.dispose())),this._vaoCaches.clear()}get newCache(){return this._newCache}getVaoCache(e,r){const s=Array.from(e).join("."),t=JSON.stringify(r),n=this._vaoCaches.get(s,t);if(n)return n;const a=new i.VaoCache(this,e,r);return this._vaoCaches.set(s,t,a),a}bindTechnique(e,r,s,t){return this.useProgram(e.program),this.setPipelineState(e.getPipeline()),s&&(e.program.bindPass(s,r),t&&e.program.bindDraw(r,s,t)),e.program}runAppleAmdDriverHelper(){this.driverTest.drawArraysRequiresIndicesTypeReset.result&&(this._appleAmdDriverHelper??=new n.AppleAmdDriverHelper(this),this._appleAmdDriverHelper.run())}get test(){}}e.RenderingContext=o,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
