/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../core/shaderLibrary/ShaderOutput","../core/shaderLibrary/output/Emissions.glsl","../core/shaderLibrary/output/OutputHighlight.glsl","../core/shaderLibrary/util/AlphaCutoff","../core/shaderLibrary/util/ColorConversion.glsl","../core/shaderModules/interfaces","../lib/OITPass"],(function(o,l,r,i,t,s,a,e){"use strict";function u(o,u){o.include(i.OutputHighlight,u),o.include(r.Emissions,u),o.fragment.include(s.ColorConversion);const n=u.output===l.ShaderOutput.ObjectAndLayerIdColor,d=l.isColorEmission(u.output),f=l.isColorOrColorEmission(u.output)&&u.oitPass===e.OITPass.ColorAlpha,g=l.isColorOrColorEmission(u.output)&&u.oitPass!==e.OITPass.ColorAlpha,c=u.discardInvisibleFragments;let h=0;(g||d||f)&&o.outputs.add("fragColor","vec4",h++),d&&o.outputs.add("fragEmission","vec4",h++),f&&o.outputs.add("fragAlpha","float",h++),o.fragment.code.add(a.glsl`
    void outputColorHighlightOID(vec4 finalColor, const in vec3 vWorldPosition) {
      ${a.If(n,a.glsl`finalColor.a = 1.0;`)}

      ${a.If(c,a.glsl`if (finalColor.a < ${a.glsl.float(t.alphaCutoff)}){
              discard;
              return;
            }`)}

      finalColor = highlightSlice(finalColor, vWorldPosition);
      ${a.If(f,a.glsl`fragColor = premultiplyAlpha(finalColor);
             fragAlpha = finalColor.a;`)}
      ${a.If(g,"fragColor = finalColor;")}
      ${a.If(d,"fragEmission = getEmissions();")}
      calculateOcclusionAndOutputHighlight();
      ${a.If(n,"outputObjectAndLayerIdColor();")}
    }
  `)}o.outputColorHighlightOID=u,Object.defineProperty(o,Symbol.toStringTag,{value:"Module"})}));
