/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../../core/libs/gl-matrix-2/math/mat4","../../../../core/libs/gl-matrix-2/factories/mat4f64","../core/shaderModules/interfaces","../core/shaderModules/Matrix4PassUniform","../lib/VertexAttribute"],(function(e,i,r,t,a,o){"use strict";function s(e,r={needUVs:!0,needEyeDirection:!0}){e.attributes.add(o.VertexAttribute.POSITION,"vec2"),e.varyings.add("worldRay","vec3");const{needUVs:s,needEyeDirection:c}=r;s&&e.varyings.add("uv","vec2"),c&&e.varyings.add("eyeDir","vec3"),e.vertex.uniforms.add(new a.Matrix4PassUniform("inverseProjectionMatrix",((e,i)=>i.camera.inverseProjectionMatrix)),new a.Matrix4PassUniform("inverseViewMatrix",((e,r)=>i.invertOrIdentity(n,r.camera.viewMatrix)))),e.vertex.main.add(t.glsl`
    vec3 posViewNear = (inverseProjectionMatrix * vec4(position, -1.0, 1.0)).xyz;
    ${t.If(c,"eyeDir = posViewNear;")}
    worldRay = (inverseViewMatrix * vec4(posViewNear, 0)).xyz;
    ${t.If(s,"uv = position * 0.5 + vec2(0.5);")}
    gl_Position = vec4(position, 1, 1);
  `)}const n=r.create();e.ScreenSpacePassAtmosphere=s,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
