/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["require","exports","../core/shaderLibrary/ShaderOutput","../core/shaderTechnique/ReloadableShaderModule","../core/shaderTechnique/ShaderTechnique","../lib/basicInterfaces","../lib/StencilUtils","../lib/VertexAttribute","../../../../chunks/Terrain.glsl","../../../webgl/enums","../../../webgl/renderState"],(function(e,t,i,r,l,n,u,a,s,c,d){"use strict";class h extends l.ShaderTechnique{constructor(t,i,l){super(t,i,new r.ReloadableShaderModule(s.Terrain,(()=>new Promise(((t,i)=>e(["./Terrain.glsl"],t,i))))),l,o),this.type="TerrainTechnique",this.useStencil=!1}initializePipeline(e){return this._stencilPipelineState=this._createPipeline(e,!0),this._createPipeline(e,!1)}_createPipeline(e,t){const{renderOccluded:r,output:l}=e,a=e.backfaceCullingEnabled&&!r;return d.makePipelineState({blending:r?d.blendWithPremultipliedAlpha:null,culling:a?d.backFaceCullingParams:null,depthTest:r?null:{func:c.CompareFunction.LESS},depthWrite:r?null:d.defaultDepthWrite,colorWrite:d.defaultColorWrite,stencilTest:t?u.renderWhenBitIsNotSet(n.StencilBits.IntegratedMeshMaskExcluded):null,drawBuffers:l===i.ShaderOutput.Depth?{buffers:[c.SpecialDrawBuffers.NONE]}:null})}getPipeline(){return this.useStencil?this._stencilPipelineState:super.getPipeline()}}const o=new Map([[a.VertexAttribute.POSITION,0],[a.VertexAttribute.UV0,1],[a.VertexAttribute.NORMALCOMPRESSED,2]]);t.TerrainTechnique=h,t.vertexAttributeLocations=o,Object.defineProperty(t,Symbol.toStringTag,{value:"Module"})}));
