/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../chunks/tslib.es6","../../../core/Accessor","../../../core/Collection","../../../core/accessorSupport/decorators/property","../../../core/has","../../../core/Logger","../../../core/RandomLCG","../../../core/accessorSupport/decorators/subclass","./LineSnapper","./ParallelLineSnapper","./RightAngleSnapper","./RightAngleTriangleSnapper","./SnappingDomain","./snappingUtils"],(function(e,n,i,t,p,s,o,r,a,c,l,g,S,h,d){"use strict";e.SelfSnappingEngine=class extends i{constructor(e){super(e),this.updating=!1,this._snappers=new t,this._domain=h.SnappingDomain.SELF}initialize(){this._snappers.push(new l.ParallelLineSnapper(this.view,this.options),new c.LineSnapper(this.view,this.options),new g.RightAngleSnapper(this.view,this.options),new S.RightAngleTriangleSnapper(this.view,this.options))}set options(e){this._set("options",e);for(const n of this._snappers)n.options=e}async fetchCandidates(e,n,i){if(!(n&this._domain&&this.options.effectiveSelfEnabled))return[];const t=[];for(const p of this._snappers.items)for(const n of p.snap(e,i))t.push(n);return d.sortCandidatesInPlace(e,t),t}},n.__decorate([p.property({readOnly:!0})],e.SelfSnappingEngine.prototype,"updating",void 0),n.__decorate([p.property({constructOnly:!0})],e.SelfSnappingEngine.prototype,"view",void 0),n.__decorate([p.property()],e.SelfSnappingEngine.prototype,"options",null),e.SelfSnappingEngine=n.__decorate([a.subclass("esri.views.interactive.snapping.SelfSnappingEngine")],e.SelfSnappingEngine),Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
