/*
All material copyright ESRI, All Rights Reserved, unless otherwise specified.
See https://js.arcgis.com/4.31/esri/copyright.txt for details.
*/
define(["exports","../../../core/Handles","../../../core/maybe","../../../core/reactiveUtils","./constants","./HoveredPoints","./InputRepresentation3D","./ProfileLines3D"],(function(e,t,i,n,s,o,r,a){"use strict";class h{constructor(e,i){this._handles=new t,this._inputRepresentation=new r.InputRepresentation3D({view:e}),this._hoveredPoints=new o.HoveredPoints({view:e}),this._profileLines=new a.ProfileLines3D({view:e}),this._handles.add([n.watch((()=>i.viewModel.hoveredPoints),(e=>this._hoveredPoints.update(e)),n.syncAndInitial),n.watch((()=>{const{state:e,editable:t,highlightEnabled:n,viewModel:s}=i,o=s.input;return o&&(o.commitProperty("geometry"),o.commitProperty("layer")),{input:o,state:e,editable:t,highlightEnabled:n}}),(e=>this._updateInputRepresentation(e)),n.syncAndInitial),n.watch((()=>i.viewModel.chartData),(e=>this._profileLines.update(e)),n.syncAndInitial),n.watch((()=>i.viewModel.input?.geometry),(()=>{this._profileLines.remove()}),n.syncAndInitial)])}destroy(){this._handles=i.destroyMaybe(this._handles),this._inputRepresentation=i.destroyMaybe(this._inputRepresentation),this._hoveredPoints=i.destroyMaybe(this._hoveredPoints),this._profileLines=i.destroyMaybe(this._profileLines)}_updateInputRepresentation({input:e,state:t,editable:i,highlightEnabled:n}){const o=this._inputRepresentation;if(!n)return o.remove();t===s.ElevationProfileState.Selected?o.showHighlight(e):t!==s.ElevationProfileState.Created||i?o.remove():o.showReshaping(e)}}e.ElevationProfileView3D=h,Object.defineProperty(e,Symbol.toStringTag,{value:"Module"})}));
